'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var tslib = require('tslib');
var React = require('react');
var cx = require('clsx');
var core = require('@mantine/core');
var useHighlight = require('./use-highlight.js');
var CopyIcon = require('./CopyIcon.js');
var CodeHighlight_module = require('./CodeHighlight.module.css.js');
var CodeHighlight_theme_module = require('./CodeHighlight.theme.module.css.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e['default'] : e; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var cx__default = /*#__PURE__*/_interopDefaultLegacy(cx);

const classes = Object.assign(Object.assign({}, CodeHighlight_module['default']), { root: cx__default(CodeHighlight_module['default'].root, CodeHighlight_theme_module['default'].theme) });
const defaultProps = {
    copyLabel: 'Copy code',
    copiedLabel: 'Copied',
    language: 'tsx',
    withCopyButton: true,
};
const CodeHighlight = core.factory((_props, ref) => {
    const props = core.useProps('CodeHighlight', defaultProps, _props);
    const { classNames, className, style, styles, unstyled, vars, children, code, copiedLabel, copyLabel, language, withCopyButton, highlightOnClient } = props, others = tslib.__rest(props, ["classNames", "className", "style", "styles", "unstyled", "vars", "children", "code", "copiedLabel", "copyLabel", "language", "withCopyButton", "highlightOnClient"]);
    const getStyles = core.useStyles({
        name: 'CodeHighlight',
        props,
        classes,
        className,
        style,
        classNames,
        styles,
        unstyled,
    });
    const getCodeProps = useHighlight.useHighlight({
        code,
        language: language,
        highlightOnClient,
    });
    return (React__default.createElement(core.Box, Object.assign({}, getStyles('root'), { ref: ref }, others, { dir: "ltr" }),
        withCopyButton && (React__default.createElement(core.CopyButton, { value: code.trim() }, ({ copied, copy }) => (React__default.createElement(core.Tooltip, { label: copied ? copiedLabel : copyLabel, fz: "sm", position: "left" },
            React__default.createElement(core.ActionIcon, Object.assign({ onClick: copy, variant: "none" }, getStyles('copy')),
                React__default.createElement(CopyIcon.CopyIcon, { copied: copied })))))),
        React__default.createElement(core.ScrollArea, { type: "auto", dir: "ltr", offsetScrollbars: false },
            React__default.createElement("pre", Object.assign({}, getStyles('pre')),
                React__default.createElement("code", Object.assign({}, getStyles('code'), getCodeProps()))))));
});
CodeHighlight.displayName = '@mantine/core/CodeHighlight';

exports.CodeHighlight = CodeHighlight;
//# sourceMappingURL=CodeHighlight.js.map
